structure AnalyzeTreeList =
struct   
    structure T = TransList
    structure O = Output   
    structure S = Solve   

    fun onlySolve (result, clauses) = let        
        fun newRel () = S.F.new result	
        val (clause) = T.translate newRel clauses  
        val _ = print "\n\nPreprocessing completed ... \n\n"     
        val res = S.solve (result, clause) 
        in  () end   
   
    fun solveAndPrint (result, clauses) = let        
        fun newRel () = S.F.new result	
        val (clause) = T.translate newRel clauses  
        val _ = print "\n\nPreprocessing completed ... \n\n"     
        val res = S.solve (result, clause) 
        in  (O.printResult (res)) end   

    fun solveAndCount (result, clauses) =  let	
        fun  newRel () = S.F.new result
        val (clause) = T.translate newRel clauses
        val _ = print "\n\nPreprocessing completed ... \n\n"
        val res = S.solve (result, clause)
        in (O.countResult (res)) end
  
    fun outputAll str (result, clauses) = let 
        fun  newRel () = S.F.new result
        val (clause) = T.translate newRel clauses
        val _ = print "\n\nPreprocessing completed ... \n\n"
        val res = S.solve (result, clause)
        val _ = O.countResult (res)
        in (O.outputResult str (res)) end 

    fun outputAllS (result, clauses) = let 
        fun  newRel () = S.F.new result
        val (clause) = T.translate newRel clauses
        val _ = print "\n\nPreprocessing completed ... \n\n"
        val res = S.solve (result, clause)
        val _ =  O.countResult (res)
        in (O.outputS ([], true) (res)) end 

    fun outputAllD (result, clauses) = let 
        fun  newRel () = S.F.new result
        val (clause) = T.translate newRel clauses
        val _ = print "\n\nPreprocessing completed ... \n\n"
        val res = S.solve (result, clause)
        val _ = O.countResult(res)
        in (O.outputD ([], true) (res)) end 

    fun outputAllStr (result, clauses) = let 
        fun  newRel () = S.F.new result
        val (clause) = T.translate newRel clauses
        val _ = print "\n\nPreprocessing completed ... \n\n"
        val res = S.solve (result, clause)
        val _ = O.countResult (res) 
        in O.outputStr ([], true) (res) end 
   
    fun output str (select, univ, count) (result, clauses) = let	
        fun  newRel () = S.F.new result   
        val (clause) = T.translate newRel clauses   
        val res = S.solve (result, clause)  
        in (if count then O.countResult (res) else ();
            O.output str (select, univ) (res)) end

    fun outputD (select, univ, count) (result, clauses) = let
        fun  newRel () = S.F.new result   
        val (clause) = T.translate newRel clauses
        val res = S.solve (result, clause)
        in (if count then O.countResult (res) else (); 
            O.outputD (select, univ) res ) end

    fun outputS (select, univ, count) (result, clauses) = let
        fun  newRel () = S.F.new result
        val (clause) = T.translate newRel clauses
        val res = S.solve (result, clause)
        in (if count then O.countResult (res) else (); 
            O.outputS (select, univ) res ) end

    fun outputStr (select, univ, count) (result, clauses) = let
        fun  newRel () = S.F.new result
        val (clause) = T.translate newRel clauses
        val res = S.solve (result, clause)
        in (if count then O.countResult (res)else (); 
            O.outputStr (select, univ) res) end

end









