structure HornPlus =

struct open Tree

(* constraints *)


   datatype ind  =	Const of int	|	Var of int    
  
 
   datatype pre = 	U of string * ind list
		|	N of string * ind list
		|	Eq of ind * ind
		|	Neq of ind * ind
        	|	FunApp of ind * (int list -> int) * ind list  
		|	And of pre * pre
		|	Or of pre * pre
		|	Exists of int * pre
		|	CheapOr of pre * pre
		|	CheapExists of int * pre
		|	Yes | No
		
   datatype clause = 	One
		|	R of string * ind list
		|	Implies of pre * clause
	        |	Break of clause
		|	Both of clause * clause
		|	Forall of int * clause

   fun listToClause [] = One
    |  listToClause [c] = c
    |  listToClause (c::cs) = Both (c, listToClause cs)
   
end






