structure RelTable = 
struct 

structure PairItem = Pair (structure First = StringItem  structure Second = IntItem)
   
structure T = Table (structure Item = PairItem
	                 type value = int)
structure I = Table (structure Item = IntItem
		         type value = string * int)

structure TT = Table (structure Item = IntItem
	                  type value = int)

val relTable = ref (T.makeTable 256)
val invTable = ref (I.makeTable 256)
val idxTable = ref (TT.makeTable 256)       
val i = ref 0

fun resetTab () = (relTable := (T.makeTable 256);
                   invTable := (I.makeTable 256);
                   idxTable := (TT.makeTable 256);
                   i:=0)

fun getIndex newRel (f,k) = 
      if T.hasValue (!relTable, (f,k)) 
      then valOf (T.sub (!relTable, (f,k)))
      else let
           val _ = i:= !i + 1
           val r = newRel ()
	   val _ = T.update (!relTable, (f,k), r)
	   val _ = TT.update (!idxTable, r, !i)
	   val _ = I.update (!invTable, r,(f,k))
	   in r end

  
fun hasIndex (f,k) = T.hasValue (!relTable, (f,k))

fun getIdx r = case TT.sub (!idxTable, r)
     of SOME i => i
      | NONE => ( print "\nIllegal index for relations!!!\n\n"
		; raise Fail "")

fun getItem i = case I.sub (!invTable,i)
     of SOME (f,k) => (f,k)
      | NONE => ( print "\nIllegal index for relations!!!\n\n"
		; raise Fail "")

fun getList () = List.rev(I.toList (!invTable)) 

end
