functor TreeItem (structure RelItem      : Item
		  structure AtomItem     : Item) =

struct 
    datatype tree = 	Atom of AtomItem.item
		|	Struct of RelItem.item * tree list

    type item = tree

    fun toWord (Atom item) = AtomItem.toWord item + 0wx3
     |  toWord (Struct (f, args)) = let
		fun doit ([], w) = w
		 |  doit (a::aa, w) = (toWord a) + 0wx1f*w
                in 
		    doit (args, RelItem.toWord f)
		end


    fun toCharList tree = let

    	fun doit (Atom item, list) = String.explode (AtomItem.toString item) :: list
     	 |  doit (Struct (f, args), list) = let
		fun doArgs [] =  [#")"] :: list
                 |  doArgs [a] = doit (a, [#")"] :: list)
		 |  doArgs (a::aa) = doit (a, [#",", #" "] :: doArgs aa)
		in
		    String.explode (RelItem.toString f) :: 
		    [#" ", #"("] :: 
		    (doArgs args)
		end
	in List.concat (doit (tree, []))
	end

    fun toString tree = String.implode (toCharList tree)

end
