structure Vars : Vars =

struct
   structure T = Table (structure Item = StringItem
			type value = int)
   type varTable = int ref * T.table

   fun new() = (ref 0, T.nullTable ())

   fun add ((n, table), str) = let
       val m = !n
       val _ = (n := m+1)
       in T.add (table, str, m); m
       end

   fun bound ((_,table),str) = T.hasValue (table,str)
   fun get ((_,table), str) = case T.sub (table,str)
	of SOME x => x
	|  NONE   => raise (Fail "Accessing unknown variable?\n\n")

   fun remove ((_, table), str) = T.remItem (table,str)
end
