open Vars
	
%%

%name Clause
%verbose
%arg () : unit

%eop EOF
%pos int*int

%right 

%term 	 EOF
       | OPEN | CLOSE | COMMA
       | NOT 
       | AND | OR | IMPLIES | BREAK
       | EQ | NEQ
       | YES | NO
       | EXISTS | FORALL | DOT
       | NAME of string

%nonterm  T of Intern.intern
	| T1 of Intern.intern
	| T2 of Intern.intern
	| T3 of Intern.intern
	| T4 of Intern.intern
	| Q of Intern.intern
	| QQ of Intern.intern
	| N of Intern.intern
	| ARGS of Intern.intern list
	| ARGS1 of Intern.intern list
	| S of Intern.intern list
 
%start S
%noshift EOF 

%%

T:   FORALL NAME DOT T	   (Intern.Forall (NAME, T))
   | EXISTS NAME DOT T     (Intern.Exists (NAME, T))
   | T1		   	   (T1)

T1:  T2 IMPLIES T	   (Intern.Implies (T2, T))
   | T2 BREAK T	   	   (Intern.Implies (T2, Intern. Break T))      
   | T2			   (T2)
  
T2:  T3 OR T2		   (Intern.Or (T3,T2))
   | T3			   (T3)

T3:  T4 AND T3		   (Intern.And (T4,T3))
   | T4			   (T4)

T4:  OPEN T CLOSE	   (T)
   | Q			   (Q)
   | N			   (N)
   | YES		   (Intern.Yes)
   | NO			   (Intern.No)
    
Q:   NAME ARGS		   (Intern.Lit (NAME, ARGS))
   | QQ EQ QQ		   (Intern.Eq  (QQ1, QQ2))
   | QQ NEQ QQ		   (Intern.Neq (QQ1, QQ2))

N:    NOT NAME ARGS	   (Intern.NLit (NAME, ARGS))

QQ:  NAME		   (Intern.Atom NAME)
     | NAME ARGS	   (Intern.Lit (NAME, ARGS))

ARGS: OPEN CLOSE	   ([])
     | OPEN ARGS1 CLOSE    (ARGS1)

ARGS1: QQ                  ([QQ])
     | QQ COMMA ARGS1	   (QQ :: ARGS1)

S:     T		   ([T])
     | T4 S		   (T4 :: S)
