structure BooleanMatrix = 

struct 
   structure B = Matrix (structure Content = BooleanContent)
   open B

   fun reduce m = let
	val m2 = mult (m,m)
	
	fun doRow ([],_) = []
	 |  doRow (row,[]) = row
	 |  doRow (left as (y1,true)::rest1, right as (y2,true)::rest2) =
		(case Int.compare (y1,y2) 
		 of GREATER	=> (y2,true):: doRow (left, rest2)
		 |  LESS	=> (y1,true):: doRow (rest1, right)
		 |  EQUAL	=> doRow (rest1,rest2)
		)

	fun doit ([],_) = []
	 |  doit (a,[]) = a
	 |  doit (x as (a,row1)::aa, y as (b,row2)::bb) = (case Int.compare (a,b)
		of GREATER => (a,row1) :: doit (aa, y)
		|  LESS    => (b,row2) :: doit (x, bb)
		|  EQUAL   => (a, doRow (row1,row2)) :: doit (aa,bb)
		)
        val m = doit (m, m2)
	in m
	end

   fun sinks m = let
	fun f ((x,[]), ss) = x :: ss
	 |  f ((x,_),  ss) = ss

	in foldr f [] m
	end

   fun sources m = sinks (transpose m)

   fun path (m,x) = case getSuccs (m,x)
	of [] 	=> [x]
	|  (y,true)::_ => x :: path (m,y)
	|  (y,false)::_ => raise (Fail "\n false ???\n\n")

   fun removePath (m, list) = foldl (fn (x,m) => rem (m,x)) m list

(* ... decomposes a transitively closed acyclic graph into paths *)

   fun decompose m = let
	fun doit (m,dec) = case sources m
		of [] => dec
		|  (x::_) => let
	
		val p = path (reduce m,x)
		val m = removePath (m, p)
		in doit (m, p::dec)
		end
	in doit (m,[])
	end

end
