signature Content =

sig
	eqtype content
	val zero	:	content
	val one		:	content
	val add		:	content * content -> content
	val mult	:	content * content -> content
	val toString	:	content -> string
end

structure IntContent : Content =

struct
	type content = int
	val zero = 0
	val one = 1
	val add = (op +)
	val mult = (op * )
	val toString = Int.toString
end

structure BooleanContent : Content =

struct
	type content = bool
	val zero = false
	val one = true
	fun add (a,b) = a orelse b
	fun mult (a,b) = a andalso b
	val toString = Bool.toString
end

