signature Matrix =

sig
	type matrix 
	type content

	val range 	:	int -> int list
	val const 	:	int list -> content -> matrix
	val zero	:	int list -> matrix

	val emptyMatrix :	unit -> matrix

	val map		:	(content -> content) -> matrix -> matrix
	val add		:	matrix * matrix -> matrix
	val mult	:	matrix * matrix -> matrix
	val transpose	:	matrix -> matrix
	val ==		:	matrix * matrix -> bool

	val rem		:	matrix * int -> matrix
	
	val sub		:	matrix * (int * int) -> content

	val getDomain	:	matrix -> int list
	val getSuccs	:	matrix * int -> (int * content) list

	val listToMatrix :	(int * int * content) list -> matrix
	val llToMatrix 	:	content list list -> matrix
	val matrixToList :	matrix -> (int * int * content) list
	val toString 	:	matrix -> string
	val lineToString :	matrix * int -> string
end

	
