structure FrontEnd (* : FrontEnd *) =
   struct
      structure LrVals = ClauseLrValsFun(structure Token = LrParser.Token)
      structure Lex = ParserLexFun(structure Tokens = LrVals.Tokens)
      structure Parser = Join(structure ParserData = LrVals.ParserData
			      structure Lex=Lex
			      structure LrParser=LrParser)
	 
      fun printError fname (s,(l1,c1),(l2,c2)) = 
	 TextIO.output(TextIO.stdErr,
		       String.concat["[",fname,
				     ":",Int.toString l1,".",Int.toString c1,
				     "-",Int.toString l2,".",Int.toString c2,
				     "] ",s,"\n"
				     ])

      fun genLexer fname = let val f = TextIO.openIn fname
			       val i = fn x => TextIO.inputN(f,x)
			   in (f,Parser.makeLexer i)
			   end

      fun expandClauses inFile outFile =
	 let 
	    val (inF,lexer) = genLexer inFile
	    val (internList,_) = Parser.parse(15,lexer,printError inFile, ())
	    val _ = TextIO.closeIn inF
            val outF = TextIO.openOut outFile
	    fun put tree = (TextIO.output (outF, Intern.toString tree)
(*
			; TextIO.output1 (outF, #"\n")
*)
				)
	    val _ = app put internList
	 in 
	    TextIO.closeOut outF
	 end
     
      fun testExpansion inFile =
         let
            val (inF,lexer) = genLexer inFile
            val (internList,_) = Parser.parse(15,lexer,printError inFile, ())
            val _ = TextIO.closeIn inF
         in
            internList
         end

   end
