open Vars
	
%%

%name Clause
%verbose
%arg () : unit

%eop EOF
%pos int*int

%right 

%term 	 EOF | COPY of string
       | OPENFORMULA | CLOSEFORMULA
       | OPENLIT | CLOSELIT
       | OPENSTRING | CLOSESTRING
       | OPEN | CLOSE | COMMA
       | NOT 
       | AND | OR | IMPLIES
       | EQ | NEQ
       | YES | NO
       | EXISTS | FORALL | DOT
       | NAME of string

%nonterm   S of Intern.intern list
	|  T of Intern.intern
	| T1 of Intern.intern
	| T2 of Intern.intern
	| T3 of Intern.intern
	| T4 of Intern.intern
	| Q of Intern.intern
	| QQ of Intern.intern
	| N of Intern.intern
	| ARGS of Intern.intern list
	| ARGS1 of Intern.intern list
	| COPIES of string list
 
%start S
%noshift EOF 

%%
S:   EOF		   ([]: Intern.intern list)
   | COPIES S		   ((Intern.Copy (String.concat COPIES))::S)
   | OPENFORMULA T CLOSEFORMULA S   
			   (T::S)

T:   FORALL NAME DOT T	   (Intern.Forall (NAME, T))
   | EXISTS NAME DOT T     (Intern.Exists (NAME, T))
   | T1		   	   (T1)

T1:  T2 IMPLIES T	   (Intern.Implies (T2, T))
   | T2			   (T2)
  
T2:  T3 OR T2		   (Intern.Or (T3,T2))
   | T3			   (T3)

T3:  T4 AND T3		   (Intern.And (T4,T3))
   | T4			   (T4)

T4:  OPEN T CLOSE	   (T)
   | OPENLIT COPIES CLOSELIT	   
			   (Intern.Copy (String.concat COPIES))
   | OPENSTRING COPIES CLOSESTRING	   
			   (Intern.CopyString (String.concat COPIES))
   | Q			   (Q)
   | N			   (N)
   | YES		   (Intern.Yes)
   | NO			   (Intern.No)
    
Q:   NAME ARGS		   (Intern.Lit (NAME, ARGS))
   | QQ EQ QQ		   (Intern.Eq  (QQ1, QQ2))
   | QQ NEQ QQ		   (Intern.Neq (QQ1, QQ2))
   | OPENLIT COPIES CLOSELIT
                           (Intern.Copy (String.concat COPIES))


N:    NOT NAME ARGS	   (Intern.NLit (NAME, ARGS))

COPIES:   COPY		   ([COPY])
   |  	  OPENFORMULA T CLOSEFORMULA
			   ([Intern.toString T])
   |      COPY COPIES	   (COPY :: COPIES)
   |  	  OPENFORMULA T CLOSEFORMULA COPIES
			   ((Intern.toString T):: COPIES)

QQ:  NAME		   (Intern.Atom NAME)
     | OPENSTRING COPIES CLOSESTRING       
			   (Intern.CopyString (String.concat COPIES))
     | NAME ARGS	   (Intern.Lit (NAME, ARGS))
     | OPENLIT COPIES CLOSELIT
                           (Intern.Copy (String.concat COPIES))

ARGS: OPEN CLOSE	   ([])
     | OPEN ARGS1 CLOSE    (ARGS1)

ARGS1: QQ                  ([QQ])
     | QQ COMMA ARGS1	   (QQ :: ARGS1)


