functor PairElement (structure First:  ORDERED_ELEMENT
		     structure Second: ORDERED_ELEMENT) : ORDERED_ELEMENT =

struct 
   type element = First.element * Second.element
   fun cmp ((a1,b1), (a2,b2)) = case First.cmp (a1,a2)
	of GREATER => GREATER
	|  LESS    => LESS
	|  EQUAL   => Second.cmp (b1,b2)
end

functor ListElement (structure E: ORDERED_ELEMENT) : ORDERED_ELEMENT =

struct
   type element = E.element list
   
   fun cmp ([],[]) = EQUAL
    |  cmp ([],_ ) = LESS
    |  cmp (_ ,[]) = GREATER
    |  cmp (a::aa,b::bb) = case E.cmp (a,b)
	of GREATER => GREATER
	|  LESS    => LESS
	|  EQUAL   => cmp (aa,bb)
end

structure IntElement : ORDERED_ELEMENT =

struct
   type element = int
   val cmp = Int.compare
end

structure IntListElement : ORDERED_ELEMENT =
	ListElement (structure E = IntElement)

structure IntListPairElement : ORDERED_ELEMENT =
	PairElement (structure First = IntListElement
		     structure Second = IntListElement)

