structure ErrUtils =
struct

     exception Error

     local

	 fun printMsg  msg  = (print " "; print msg)
	 fun printMsgs msgs = (app printMsg msgs; print "\n")

     in

     fun message msgs = (print "\n\tMessage:"; printMsgs msgs)

     fun warning msgs = (print "\n\tWarning:"; printMsgs msgs)

     fun error   msgs = (print "\n\tError:"; printMsgs msgs; raise Error)

     fun bug (module,function) msgs = ( print "\n\tInternal bug in "
				      ; print module   ; print "."
				      ; print function ; print ":"
				      ; printMsgs msgs ; raise Error)

     end

end
