structure ErrorMsg : ERRORMSG = 
struct
   local
     val error_count = ref 0
     and warn_count  = ref 0
   in

   structure Position : POSITION =
   struct
      local
        val lineNum = ref 1
      in
        type position = int
        fun init () = (lineNum := 1) 
        fun nextLine() = (lineNum := !lineNum+1)
        fun nextChar() = ()
        fun currentPosition()  = !lineNum
        fun show (p:int) = "line " ^ Int.toString p
      end
   end (* POSITION *)

     exception Syntax of string
     exception Bug    of string
     exception Error
     val error_flag = ref false
     fun init() = (error_count := 0; warn_count := 0; error_flag := false)
     fun error pos msg = 
           (error_flag := true;
            error_count := !error_count+1;
            print ("error (" ^ Position.show pos ^ "): " ^ msg ^ "\n");
            raise Syntax "")
     fun error_ft (pos1,pos2) msg =
           (error_flag := true;
            error_count := !error_count+1;
            print("error (" ^ Position.show pos1 ^ " - " ^ 
                          Position.show pos2  ^ "): " ^ msg ^ "\n");
            raise Syntax "")
     fun warn pos msg =
           (warn_count := !warn_count+1;
            print("warning (" ^ Position.show pos ^ "): " ^ msg ^ "\n"))
     fun bug(module, function) = 
              raise Bug (module ^ "." ^ function)
     fun abort (msg:string) = (print msg; print "\n"; raise Error)
   end
end  

