signature Forest =

sig
   type forest

   
   val makeForest	:	int -> forest
   val nullForest 	:	unit -> forest
   val numberOfNodes 	: 	forest -> int

   val new	:	forest -> int
   val insert 	:	forest * int * int list -> bool
   val hasElem	:	forest * int * int list -> bool

   val toList 	:	forest * int * int list -> int list list
   val appF	:	(int list -> unit) -> forest * int * int list -> unit
   val foldF	:	(int list * 'b -> 'b) -> 'b -> 
			forest * int * int list -> 'b

   val count 	:	forest * int -> int

   val max	:	forest -> int
   val zeroFraction	:	forest -> real
   val average	:	forest -> real
 (*  val resetForest 	:	forest * int -> unit *)
   val resetForest:     forest -> unit 
end
