structure IntUtils =

struct 
   fun sort list = let
       val list = map (fn x => [x]) list

       fun merge ([],b)		 	= b
        |  merge (a,[])			= a
        |  merge (a as x::xs, b as y::ys)= if x >= y then x :: merge (xs,b)
					  else 		 y :: merge (a,ys)

       fun pairMerge []			= []
        |  pairMerge [x]		= [x]
        |  pairMerge (x1 :: x2 :: rest) = (merge (x1,x2)) :: pairMerge rest
   
       fun doit []  = []
        |  doit [x] = x
        |  doit x   = doit (pairMerge x)
       in doit list
       end 

   fun rsort list = let
       val list = map (fn x => [x]) list

       fun merge ([],b)                 = b
        |  merge (a,[])                 = a
        |  merge (a as x::xs, b as y::ys)= if x <= y then x :: merge (xs,b)
                                          else           y :: merge (a,ys)

       fun pairMerge []                 = []
        |  pairMerge [x]                = [x]
        |  pairMerge (x1 :: x2 :: rest) = (merge (x1,x2)) :: pairMerge rest

       fun doit []  = []
        |  doit [x] = x
        |  doit x   = doit (pairMerge x)
       in doit list
       end

   fun remDup list = let
       val list = sort list
       fun doit ([], set) = set
	|  doit (x::xs, []) = doit (xs, [x])
	|  doit (x::xs, set as y::_) = if x = y then doit (xs,set)
				       else doit (xs, x::set)
       in doit (list,[])
       end

   fun minus (A, B) = let
	val A = remDup A
	val B = remDup B
	fun doit ([],_) = []
	 |  doit (A,[]) = A
	 |  doit (A as x::xs, B as y::ys) = if x < y then
		x:: doit (xs, B) else       if x > y then
		doit (A, ys)	 else
		doit (xs,ys)
	in doit (A,B)
	end	
	
   fun hasElement ([],x) = false
    |  hasElement (y::ys,x) = if x = y then true
			      else hasElement (ys,x)

   fun log n = let
        fun doit (m,k) = if m>=n then k
                else doit (2* m, k+1)
        in doit (1,0)
        end

   fun exp (x,n) = let
	fun doit n = if n = 0 then 1
	    else let val z = doit (n div 2)
	         in if 1 = n mod 2 then x * z * z
		    else z * z
		 end
        in doit n
	end

   fun sum list = let
       fun doit ([], result)    = result
        |  doit (x::xs, result) = doit (xs, x+result)
       in doit (list, 0)
       end
	
end
