functor Link (structure Stack : ItemEq) =

struct
   structure Unique    = PoolEq (structure Item = Stack)
   structure LinkTable = SimpleTableEq (structure Item = Stack)

   type linkTable = Unique.pool option LinkTable.table

   fun makeLinkTable () = LinkTable.makeTable (1023, NONE: Unique.pool option) :
				linkTable

   fun link (table, oldStack, newStack) = 
		case LinkTable.sub (table, newStack)
		 of  SOME pool => Unique.insertElem (pool, oldStack)
		 |   NONE      => let 
			val pool = Unique.makePool 11
			val _    = LinkTable.update (table, newStack, SOME pool)
			in Unique.insertElem (pool, oldStack)
			end
				  

   fun getLinks (table, stack) = case LinkTable.sub (table, stack)
		 of  SOME pool => Unique.toList pool
		 |   NONE      => []
end
				   
   

