functor PairEq (structure First:ItemEq
	      structure Second:ItemEq) : ItemEq =

struct
   type item = First.item * Second.item

   fun eq ((x1,y1),(x2,y2)) = First.eq (x1,x2) andalso Second.eq (y1,y2)

   fun toString (a,b) = (First.toString a)^"/"^(Second.toString b)
(*
   fun toString (a,b) = "("^(First.toString a)^
		        ","^(Second.toString b)^")"
*)
   fun toWord (a,b) = ((First.toWord a) + 0wx7)* 0wx7ff +
		      (Second.toWord b) 

(*********************************************************************)
(* the following function is way too inefficient ...		     *)
(*								     *)
(* fun toWord (a,b) = (((First.toWord a) + 0wx7)* (0wxd3 +
		      (Second.toWord b))) div 0wxd3
								     *)
(*********************************************************************)

end

structure IntPairItemEq : ItemEq =
   PairEq (structure First = IntItem
	 structure Second = IntItem)

structure StringIntItemEq : ItemEq =
   PairEq (structure First = StringItem
	 structure Second = IntItem)
