structure PrintUtils =

struct

(* mapping int lists to char lists and strings ... *)

fun intListToCharList0 (list,acc) = let
    fun doit [] = acc
     |  doit [x] = (String.explode (Int.toString x)) @ acc
     |  doit (x::xs) = (String.explode (Int.toString x)) @
			#"," :: #" " :: doit xs
    in doit list
    end

fun intListToCharList list = intListToCharList0 (list,[])

val intListToString = String.implode o intListToCharList 

fun pairListToCharList list = let
    fun f ((x,y),list) = #"(" :: (String.explode (Int.toString x)) @
                         #"," :: (String.explode (Int.toString y)) @ 
			 #")" :: list
    fun doit [] = []
     |  doit [p] = f (p,[])
     |  doit (p::rest) = f (p, #"," :: #" " :: doit rest)
    in doit list
    end

fun pairListToString list = String.implode (pairListToCharList list)

fun intListPairListToCharList list = let
    fun doPair ((xx,yy), acc) = #"\t" :: intListToCharList0 (xx,
			       #"\t" :: #"/" :: #"\t" ::
			       intListToCharList0 (yy, 
			       #"\n" :: acc))
    in #"\n" :: #"\n" :: foldr doPair [#"\n"] list
    end

val intListPairListToString = String.implode o intListPairListToCharList 
    
fun intListListToCharList list = let
    fun f (l, acc) = #"(" :: intListToCharList0 (l, #")" :: acc)
    fun doit [] = []
     |  doit [l] = f (l,[])
     |  doit (l::ll) = f (l, #"," :: #" " :: doit ll)

    in #"\t" :: doit list
    end

val intListListToString = String.implode o intListListToCharList

fun largeIntListToCharList0 (list,acc) = let
    fun doit [] = acc
     |  doit [x] = (String.explode (LargeInt.toString x)) @ acc
     |  doit (x::xs) = (String.explode (LargeInt.toString x)) @
			#"," :: #" " :: doit xs
    in doit list
    end

fun largeIntListListToCharList list = let
    fun f (l, acc) = #"(" :: largeIntListToCharList0 (l, #")" :: acc)
    fun doit [] = []
     |  doit [l] = f (l,[])
     |  doit (l::ll) = f (l, #"," :: #" " :: doit ll)

    in #"\t" :: doit list
    end

val largeIntListListToString = String.implode o largeIntListListToCharList

(* mapping string lists to char lists and strings ... *)

fun stringListToCharList list = let
    fun doit [] = []
     |  doit [x] = String.explode x
     |  doit (x::xs) = String.explode x @ #"," :: #" " ::
		       doit xs
    in #"\t" :: doit list
    end

val stringListToString  = String.implode o stringListToCharList
end
