(* priority-queue.sig
 *
 * COPYRIGHT (c) 1995 by Christian Fecht.  See COPYRIGHT file for details.
 *
 * AUTHOR:  Christian Fecht
 *          FB 14 - Universitaet des Saarlandes
 *          Postfach 151150
 *          66041 Saarbruecken 
 *          fecht@cs.uni-sb.de 
 *)



signature PRIORITY_QUEUE =
  sig
    structure Element : ORDERED_ELEMENT

    type pqueue

    exception Empty

    val empty     : pqueue
    val isEmpty   : pqueue -> bool
    val enqueue   : pqueue * Element.element -> pqueue
    val dequeue   : pqueue -> Element.element * pqueue
    val findMin   : pqueue -> Element.element
    val deleteMin : pqueue -> pqueue
  end
