funsig simpleTableEq (structure Item: ItemEq) =
   sig
      type 'a table
	 
      val nullTable :  'a -> 'a table
      val makeTable : int * 'a -> 'a table
      val resetTable : 'a table * int -> unit
	 
      val nullValue : 'a table -> 'a
      val hasValue  : 'a table * Item.item -> bool
      val update    : ('a table * Item.item * 'a) -> unit
      val add       : ('a table * Item.item * 'a) -> unit
      val sub       : 'a table * Item.item -> 'a
      val extract   : 'a table * Item.item -> 'a
      val remItem   : 'a table * Item.item -> unit

      val fromList  : 'a -> (Item.item * 'a) list -> 'a table
      val toList    : 'a table -> (Item.item * 'a) list
      val copyTable : 'a table -> 'a table
      val map 	    : ('a -> 'b) -> 'a table -> 'b table
      val map0 	    : ('b * ('a -> 'b)) -> 'a table -> 'b table
	 
      val max	    : 'a table -> int
      val zeroFraction   : 'a table -> real
      val average   : 'a table -> real

      val printTable : ('a -> string) -> 'a table -> unit 
   end

