functor Sort (structure E : ORDERED_ELEMENT) : Sort =

struct
   
   infix 5 >=
   infix 5 ==

   type element = E.element

   fun (x >= y) = let
       val c = E.cmp (x,y)
    in if c = EQUAL orelse c = GREATER then true
       else false
    end

   fun (x == y) = if E.cmp (x,y) = EQUAL then true else false

   fun merge ([],b)		 	= b
    |  merge (a,[])			= a
    |  merge (a as x::xs, b as y::ys)= if x >= y then x :: merge (xs,b)
 						 else y :: merge (a,ys)

   fun sort list = let
	
       val list = map (fn x => [x]) list

       fun pairMerge []			= []
        |  pairMerge [x]		= [x]
        |  pairMerge (x1 :: x2 :: rest) = (merge (x1,x2)) :: pairMerge rest
   
       fun doit []  = []
        |  doit [x] = x
        |  doit x   = doit (pairMerge x)
       in doit list
       end 

   fun remDup list = let
       val list = sort list
       fun doit [] = []
        |  doit [x] = [x]
        |  doit (x::(xs as y::_)) = if x == y then doit xs
				   else x :: doit xs
       in  doit list
       end

   fun revRemDup list = let
       val list = sort list
       fun doit ([], set) = set
	|  doit (x::xs, []) = doit (xs, [x])
	|  doit (x::xs, set as y::_) = if x == y then doit (xs,set)
				       else doit (xs, x::set)
       in doit (list,[])
       end

end
