functor SymbolTableEq (structure Item : ItemEq) = 

struct
   structure Table = TableEq (structure Item = Item
			    type value = int )

   type table = Item.item Stack.stack * Table.table

   
   fun makeTable n = (Stack.new (), Table.makeTable n) : table
   fun nullTable n = (Stack.new (), Table.nullTable ()) : table

   fun getIndex ((stack,table), item) = case Table.sub (table, item)
       of SOME x	=>	x
 	| NONE		=>	let
				val x = Stack.push (stack,item)
				val _ = Table.update (table, item, x)
				in x end

   fun addItem ((stack,table), item) = let
				val x = Stack.push (stack,item)
                                val _ = Table.add (table, item, x)
                                in x end

   fun remItem ((stack, table), item) = Table.remItem (table, item)

   fun getItem ((stack,table), x) = Stack.sub (stack,x)

   fun hasIndex ((stack,table), item) = Table.hasValue (table, item)

   fun numberOfItems (stack,_) = Stack.length stack
   fun toString (stack,table) = let
       val list = Stack.toList stack
       val n    = List.length list
       fun doit ([],_,string)    = string
	|  doit (x::xs,m,string) = let 
		val item = (Int.toString m)^":\t"^(Item.toString x)^"\n"
		in doit (xs,m-1,item^string)
		end
       in  doit (list,n-1,"")
       end
end
