functor TripleEq (structure First:ItemEq
	      structure Second:ItemEq
	      structure Third:ItemEq) : ItemEq =

struct
   type item = First.item * Second.item * Third.item

   fun eq ((x1,y1,z1),(x2,y2,z2)) = First.eq (x1,x2) andalso 
				    Second.eq (y1,y2) andalso
				    Third.eq (z1,z2)

   fun toString (a,b,c) = (First.toString a)^"/"^
			  (Second.toString b)^"/"^
			  (Third.toString c)
(*
   fun toString (a,b) = "("^(First.toString a)^
		        ","^(Second.toString b)^")"
*)
   fun toWord (a,b,c) = (((First.toWord a) + 0wx3)* 0wx7ff +
		          (Second.toWord b))* 0wx7ff +
			  (Third.toWord c) 

end

structure IntTripleItemEq : ItemEq =
   TripleEq (structure First = IntItem
	     structure Second = IntItem
	     structure Third = IntItem)

structure IntTripleItem = IntTripleItemEq

structure IntInt32IntItemEq : ItemEq =
   TripleEq (structure First = IntItem
	     structure Second = Int32Item
	     structure Third = IntItem)

structure IntInt32IntItem = IntInt32IntItemEq
