functor UnionFind (structure Item : Item) : UnionFind =

struct
    type item = Item.item
    
    structure P = Table (structure Item = Item
			 type value = Item.item * int)

    type partition = P.table

    fun newPartition list = let
	fun double x = (x,(x,1))
	val doubleList = map double list
	in P.fromList doubleList
	end

    fun find (partition, item) = let

	fun update root path = app 
	    (fn (item,_) => P.update (partition, item, (root,0)))
	    path

	fun compress item path = let
            val value as (father,int) = case P.sub (partition, item)
                of SOME value => value
                |  NONE => raise (Fail "\n\tItem not in partition!!!\n\n")
    	    in if father = item 
	       then (update item path; item)
	       else compress father (value::path)
	    end
		
	in compress item []
	end

    fun findPlus (partition, item) = let

        fun update root path = app
            (fn (item,_) => P.update (partition, item, (root,0)))
            path
                
        fun compress item path = let
            val value as (father,int) = case P.sub (partition, item)
                of SOME value => value 
                |  NONE => raise (Fail "\n\tItem not in partition!!!\n\n")
            in if father = item
               then (update item path; value)
               else compress father (value::path)
            end

        in compress item []
        end

    fun union (partition, x, y) = let
	val (z1,n1) = findPlus (partition, x)
	val (z2,n2) = findPlus (partition, y)
	in if z1 = z2 then false
	   else if n1 < n2 
		then (P.update (partition, z1, (z2,0)); 
		      P.update (partition, z2, (z2,n1+n2)); true)
		else (P.update (partition, z2, (z1,0)); 
		      P.update (partition, z1, (z1,n1+n2)); true)
	end

(* Union returns true if x and y have been in different classes ... *)

end

